<?php
/**
 * 위치별 플러그인 설정 스크립트
 *
 * 본 스크립트는 articles 플러그인의 설정 스크립트(또는 복사된)이다.
 * 본 스크립트는 설정의 작업 처리를 위한 표준적인 방법을 제시한다. 따라서 설정 스크립트를 작성할 때에는
 * 본 스크릡트를 참조하는 것이 도움이 될 것이다.
 *
 * 현제 위치에 해당하는 현제 플러그인의 설정을 한다.
 * HTML FORM 을 submit 하면 config_submit.php 에 의해서 설정 내용이 저장이될 것이다.
 * 대부분의 경우 config_submit.php 는 변경을 하지 않아도된다.
 * config.php 에서만 수정을 하고 사용하면된다.
 *
 *
 */
//
/**
 * 라이브러리 로드
 ******************************/

lib('plugin');


/**
 * 플러그인 정보
 ******************************/

$pd = dirRoot."/plugin/$ui[dir]";
include $pd."/info.php";
$cfg = config(cfgfile());





/**
 * 초기값 체크
 ******************************/

$user_checked = $rss_checked = $map_checked = NULL;
if ( isset($cfg['user']) && $cfg['user'] == 'checked' ) $user_checked = "checked";
if ( isset($cfg['rss']) && $cfg['rss'] == 'checked' ) $rss_checked = "checked";
if ( isset($cfg['map']) && $cfg['map'] == 'checked' ) $map_checked = "checked";

if ( !isset($cfg['name1']) ) $cfg['name1'] = NULL;
if ( !isset($cfg['name2']) ) $cfg['name2'] = NULL;
if ( !isset($cfg['name3']) ) $cfg['name3'] = NULL;
if ( !isset($cfg['name4']) ) $cfg['name4'] = NULL;
if ( !isset($cfg['url1']) ) $cfg['url1'] = NULL;
if ( !isset($cfg['url2']) ) $cfg['url2'] = NULL;
if ( !isset($cfg['url3']) ) $cfg['url3'] = NULL;
if ( !isset($cfg['url4']) ) $cfg['url4'] = NULL;


$hide_checked = NULL;
if ( isset($cfg['hide']) && $cfg['hide'] == 'checked' ) $hide_checked = "checked";


if ( !isset($cfg['cache']) ) $cfg['cache'] = "0";





/**
 * 캐쉬 정보를 저장할 경우, 캐쉬 옵션이 0 이면, 기존의 캐쉬 파일을 여기서 지운다.
 *******************************/

if ( empty($cfg['cache']) )
{
	$cache_file = tmp_repository . "/cache/plugin.$ui[areaname].php";
	@unlink($cache_file);
}



?>
<!-- HTML config.php header 부분은 모두 동일//-->
<html>
<head>
	<meta http-equiv=Content-Type content='text/html;charset=utf-8'>
	<link rel="stylesheet" type="text/css" href="etc/res/css/basic.css">
	<title><?=$info['name']?> 관리자 화면</title>
	<style>
		body {margin:10;}
		body, div, td { font-size: 10pt; }
		.in {height: 20;}
	</style>
</head>
<body>



<div id="title"><?=$ui['areaname']?> 위치 "<?=$info['name']?>" 설정</div>

<div style="margin-left:20; margin-top: 4;">
	<div id="key">위치</div>
	<div id="value"><?=$ui['areaname']?></div>
	<div id="key">플러그인</div>
		<div id="value"><?=$info['name']?> (<?=$ui['dir']?>) by <?=$info['author']?>
		&nbsp;&nbsp;
		<a href="#"
			style="text-decoration: line-through;"
			onclick="var w = window.open('?cate=plugin&mode=select&action=save&form_name=<?=$ui['areaname']?>','openBox','top=300,left=500,width=400,height=120'); w.focus(); return false;"
		>
			플러그인 변경
		</a>
	</div>
</div>

<div id="note"><?=$info['description']?></div>


<!------------------------------------------------//-->
<form action="?" method="post" style="display:inline;">
<input type="hidden" name="cate" value="plugin">
<input type="hidden" name="mode" value="plugin">
<input type="hidden" name="action" value="config_submit">
<input type="hidden" name="dir" value="<?=$ui['dir']?>">
<input type="hidden" name="areaname" value="<?=$ui['areaname']?>">


<table>

	
	<tr>
		<td><div id="name">표시</div></td><td>
			<input type="checkbox" name="user" value="checked" <?=$user_checked?>>사용자 가입/정보
			<input type="checkbox" name="rss" value="checked" <?=$rss_checked?>>RSS
			<input type="checkbox" name="map" value="checked" <?=$map_checked?>>사이트맵
		</td>
	</tr>

	<tr valign=top>
		<td><div id="name">추가</div></td><td>
			항목 이름
			&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
			&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
			&nbsp; &nbsp; &nbsp;
			URL
			<br>
			<input type="text" name="name1" value="<?=$cfg['name1']?>">
			<input type="text" name="url1" value="<?=$cfg['url1']?>"><br>

			<input type="text" name="name2" value="<?=$cfg['name2']?>">
			<input type="text" name="url2" value="<?=$cfg['url2']?>"><br>

			<input type="text" name="name3" value="<?=$cfg['name3']?>">
			<input type="text" name="url3" value="<?=$cfg['url3']?>"><br>

			<input type="text" name="name4" value="<?=$cfg['name4']?>">
			<input type="text" name="url4" value="<?=$cfg['url4']?>"><br>

			<div id="comment">추가할 항목의 이름, URL 을 기록하십시오.</div>

		</td>
	</tr>

	<tr>
		<td><div id="name">숨기기</div></td><td><input class="in" type="checkbox" name="hide" value="checked" <?=$hide_checked?>> 화면에 나타내지 않기</td>
	</tr>
	<tr>
		<td><div id="name">스킨</div></td>
		<td>
			<select name='skin'>
			<?
				$dirs = getdirs($pd."/skin");
				foreach( $dirs as $dir )
				{
					echo "<option value='$dir'";
					if ( isset($cfg['skin']) && $cfg['skin'] == $dir ) echo " selected";
					echo ">$dir</option>";
				}
			?>
			</select>
		</td>
	</tr>

	<tr>
		<td></td><td><input class="button_blue" type="submit" value=" 적 용 [저장] "></td>
	</tr>
</table>


</form>
<!------------------eo//-->



<script>window.resizeTo(500,700);</script>








<br><div id="key">미리보기</div><div id="value">위의 저장(변경)된 내용이 아래 바로 적용이됩니다.</div><br>
<?plugin($ui['areaname'])?>



</body>
</html>

