<?php
/**
 * 위치별 플러그인 설정 스크립트
 *
 * 최근글 제목을 리스트하기 위한 옵션 설정을 한다.
 *
 *
 */

	lib('plugin');

/**
 * 플러그인 정보
 */
$pd = dirRoot."/plugin/$ui[dir]";
include $pd."/info.php";
$file = module_repository . "/plugin.cfg.$ui[areaname].php"; //설정 파일
$cfg = config($file);

if ( !isset($cfg['category'])  ) $cfg['category'] = NULL;
if ( !isset($cfg['header'])  ) $cfg['header'] = NULL;
if ( !isset($cfg['number'])  ) $cfg['number'] = 4;
if ( !isset($cfg['width'])  ) $cfg['width'] = 120;
if ( !isset($cfg['height'])  ) $cfg['height'] = 200;
if ( !isset($cfg['length_title']) ) $cfg['length_title'] = 20;
if ( !isset($cfg['length_description']) ) $cfg['length_description'] = 0;


$price_checked = $recommend_checked = $hit_checked = NULL;
if ( isset($cfg['price']) && $cfg['price'] == 'checked' ) $price_checked = "checked";
if ( isset($cfg['recommend']) && $cfg['recommend'] == 'checked' ) $recommend_checked = "checked";
if ( isset($cfg['hit']) && $cfg['hit'] == 'checked' ) $hit_checked = "checked";


$rcdateTime = $rchits = $rcrecommend = $rchit = $rcprice = NULL;
if ( isset($cfg['order']) )
{
	$var = "rc".$cfg['order'];
	$$var = "checked";
}


$hide_checked = NULL;
if ( isset($cfg['hide']) && $cfg['hide'] == 'checked' ) $hide_checked = "checked";


if ( !isset($cfg['cache']) ) $cfg['cache'] = "0";

/**
 * 캐쉬 정보를 저장할 경우, 캐쉬 옵션이 0 이면, 기존의 캐쉬 파일을 여기서 지운다.
 */
if ( empty($cfg['cache']) )
{
	$cache_file = tmp_repository . "/cache/plugin.$ui[areaname].php";
	@unlink($cache_file);
}
?>
<? include "etc/res/php/plugin_config_header.php" ?>

<form action="?" method="post" style="display:inline;">
<input type="hidden" name="cate" value="plugin">
<input type="hidden" name="mode" value="plugin">
<input type="hidden" name="action" value="config_submit">
<input type="hidden" name="dir" value="<?=$ui['dir']?>">
<input type="hidden" name="areaname" value="<?=$ui['areaname']?>">
<!--eo //-->


<div id="comment">
	특정 카테고리(들)를 콤마로 분리하여 지정할 수 있습니다.<br>
	카테고리 생략시 전체 카테고리에서 리스트합니다.
</div>


<table>
	<tr>
		<td><div id="name">카테고리</td>
		<td>
			<input class="in" type="text" name="category" value="<?=$cfg['category']?>">
			콤마로 분리 예) desktopA,desktopB
		</td>
	</tr>
	<tr>
		<td><div id="name">헤더(타이틀)</td><td><input class="in" name="header" size=30 value="<?=$cfg['header']?>"></td>
	</tr>


	<tr>
		<td><div id="name">목록 수</td><td><input class="in" name="number" size=3 value="<?=$cfg['number']?>"></td>
	</tr>
	
	
	<tr>
		<td><div id="name">칸 너비</td><td><input class="in" name="width" size=3 value="<?=$cfg['width']?>"> 상품 1개의 칸 너비</td>
	</tr>
	
	<tr>
		<td><div id="name">칸 높이</td><td><input class="in" name="height" size=3 value="<?=$cfg['height']?>"> (너비와 높이가 일정하게 맞춰진다면 여러행으로 표시를 할 수도 있습니다.)</td>
	</tr>
	
	<tr>
		<td><div id="name">제목 길이</td><td><input class="in" name="length_title" size=3 value="<?=$cfg['length_title']?>"></td>
	</tr>
	<tr>
		<td><div id="name">내용 길이</td><td><input class="in" name="length_description" size=3 value="<?=$cfg['length_description']?>"></td>
	</tr>
	
	
	<tr>
		<td><div id="name">리스트 순서</td><td>
			<input type="radio" name="order" value="dateTime" <?=$rcdateTime?>>등록
			<input type="radio" name="order" value="hits" <?=$rchits?>>조회
			<input type="radio" name="order" value="recommend" <?=$rcrecommend?>>추천
			<input type="radio" name="order" value="hit" <?=$rchit?>>인기
			<input type="radio" name="order" value="price" <?=$rcprice?>>가격
		</td>
	</tr>
	
	
	<tr>
		<td><div id="name">표시</td><td>
			<input type="checkbox" name="price" value="checked" <?=$price_checked?>>가격
			<input type="checkbox" name="recommend" value="checked" <?=$recommend_checked?>>추천
			<input type="checkbox" name="hit" value="checked" <?=$hit_checked?>>인기
		</td>
	</tr>
	
	<tr>
		<td><div id="name">숨기기</div></td><td><input class="in" type="checkbox" name="hide" value="checked" <?=$hide_checked?>> 화면에 나타내지 않기</td>
	</tr>
	<tr>
		<td><div id="name">스킨</td>
		<td>
			<select name='skin'>
			<?
				$dirs = getdirs($pd."/skin");
				foreach( $dirs as $dir )
				{
					echo "<option value='$dir'";
					if ( isset($cfg['skin']) && $cfg['skin'] == $dir ) echo " selected";
					echo ">$dir</option>";
				}
			?>
			</select>
		</td>
	</tr>
	<tr>
		<td><div id="name">캐쉬</td>
		<td>
			<select name="cache">
				<?=@plugin_cache_options($cfg['cache'])?>
			</select>분 (0분 캐쉬 안함. 설정시 0으로)
		</td>
	</tr>
	<tr>
		<td></td><td><input type="submit" value=" 저 장 "></td>
	</tr>
</table>


</form>

<script>
	window.resizeTo(700,700);
	window.moveTo(200,100);
</script>

<br>
<div id="key">미리보기</div><div id="value">위의 저장(변경)된 내용이 아래 바로 적용이됩니다.</div>

<?
	plugin($ui['areaname']);
?>


