<?php
/**
 *
 * @note 기본 변수
 * 필요한 $mode 에서 (order, order_list 의 mode 는 제외) $category 에 현제 카테고리, 아이템의 카테고리 값이 들어간다.
 * $category 값이 세팅된 경우, $parent 에는 최 상위 카테고리 정보가 들어간다.
 * 	$parent 카테고리가 있는 경우, $child 에는 $category 값을 넣어준다.
 *	$parent 가 없을 경우, $child 는 undefined 이다.
 *	즉, 2단 카테고리일 때, $parent, $child 에 값이 들어간다. 1 단은 $chiled == undefiend
 * $item 에는 현제 아이템이 들어간다.
 * $items 에는 현제 선택된 아이템들의 정보가 들어간다.
 *
 *
 * @since 2007/03/24 $parent, $child 값에 따라, 서브 카테고리의 정보를 출력하려니 문제가 발생한다.
 *	기존의 방식에는 쇼핑몰의 경우, 최상위 카테고리에는 idx_parent 값이 없었는데, 메뉴를 처리하다보면,
 *	메인 메뉴에 쇼핑몰 최 상위 카테고리가 포함되어서 올바로 표현되지 않는다.
 *	따라서, 서브 카테고리의 정보를 출력할 때에는 $parent, $child 의 값을 신경쓰지 않고 처리를 한다.
 *
 * @since 2007/03/30 $parent, $child 값을 정하기가 쉽지 않다. 다음과 같이 정한다.
 *	현제 카테고리의 정보는 $category 에 보관된다.
 *	현제 카테고리의 부모 카테고리가 쇼핑몰 카테고리라면, $parent 에는 부모 카테고리 정보가 기록된다.
 *	자식 카테고리 존재 여부는 따지지 않는다.
 */

lib('mall');
lib('category');
lib('post');


$mallfile = sessionfile("mall");

$parent = $child = array();



/**
 * $ui['idx'] 가 카테고리 번호인 경우,
 */
if ( in_array($mode, array("write","list")) )
{
	$category = category($ui['idx']);
}
/**
 * $ui['idx'] 가 아이템 번호인 경우,
 */
else if ( in_array($mode, array("read", "reply_submit") ) )
{
	$item = item($ui['idx']);
	$category = category($item['idx_category']);
}

// 카테고리 정보가 있는 경우,
if ( isset($category) && !empty($category) )
{
	// 부모 카테고리가 있는 경우,
	if ( $category['idx_parent'] )
	{
		$c = category( $category['idx_parent'] );
		if ( $c['type'] == CATE_MALL ) $parent = $c;
		unset($c);
	}
}








/**
 * @since 2007/03/01 $firstcategory 변수 삭제. 그냥 $category[idx_parent] 를 사용.
 * @since 2007/04/06 begin.php 로 이동
 */



if ( isset($ui['idx']) )
{
	$url_modify		= "?cate=mall&mode=modify&idx=$ui[idx]";
	$url_delete		= "?cate=mall&mode=delete&idx=$ui[idx]";
}

if ( isset($category) )
{
	$url_write		= "?cate=mall&mode=write&idx=$category[idx]";
	$url_list			= "?cate=mall&mode=list&idx=$category[idx]";
}


?>
