<?php
/**
 * 데이터베이스 사용예 1
 *
 * 간단한 사용법을 설명한다.
 *
 * @package example
 */
/**
 * 라이브러리 로드
 */
$_dirRoot = "../.."; include_once("$_dirRoot/lib/default.php");
lib('mysql');

$db = new MySQL("root", "1111", "siteapi");



// 데이터베이스 쿼리
$db->query("SELECT * FROM post LIMIT 10,20");

// 쿼리 결과 출력
// $db 객체의 row() 메소드는 한 번에 한 행을 가져온다. 데이터가 없으면 거짓을 리턴.
// @see ../../lib/mysql.php
while ( $post = $db->row() )
{
	echo "idx: $post[idx], title: $post[title]<br>";
}



// ========================== 중첩 쿼리
// $db->query() 를 할 때, 이전 결과셋은 파괴가 된다. 따라서 아래의 문장은 에러가 발생한다.
$db->query("SELECT * FROM post LIMIT 10,20");
while ( $post = $db->row() )
{
	// 여기서 에러를 만든다. query() 를 하고 결과를 반복적으로 추출하는 동안에 또 다시 query() 를 해서 다음 결과셋을 읽으려 할 때, 에러가 발생한다.
	// $db->query("UPDATE post SET hits = hits+1 WHERE idx=$post[idx]");
}

// ========================== 충첩 쿼리 방법
// PHP 버젼 5 부터는 클래스 복사 연산자가 있지만, 그 이하 버젼에서는 아래와 같이 새로 객체를 만들어
// 기존 링크를 받아서 사용한다.
$db2 = new MySQL();
$db2->attach( $db->detach() );
$db->query("SELECT * FROM post LIMIT 10,20");
while ( $post = $db->row() )
{
	// 아래와 같이 새로 만든 객체를 통해서 쿼리를 한다.
	$rc = $db2->query("UPDATE post SET hits = hits+1 WHERE idx=$post[idx]");
	if ( ! $rc ) die ("something wrong");
}



?>
